commit bf01dcd117ceabff839bb002b9eba4494656fd02
Author: David Malcolm <dmalcolm@redhat.com>
Date:   Fri Jun 21 08:46:14 2024 -0400

    testsuite: check that generated .sarif files validate against the SARIF schema [PR109360]
    
    This patch extends the dg directive verify-sarif-file so that if
    the "jsonschema" tool is available, it will be used to validate the
    generated .sarif file.
    
    Tested with jsonschema 3.2 with Python 3.8
    
    gcc/ChangeLog:
            PR testsuite/109360
            * doc/install.texi: Mention optional usage of "jsonschema" tool.
    
    gcc/testsuite/ChangeLog:
            PR testsuite/109360
            * lib/sarif-schema-2.1.0.json: New file, downloaded from
            https://docs.oasis-open.org/sarif/sarif/v2.1.0/os/schemas/sarif-schema-2.1.0.json
            Licensing information can be seen at
            https://github.com/oasis-tcs/sarif-spec/issues/583
            which states "They are free to incorporate it into their
            implementation. No need for special permission or paperwork from
            OASIS."
            * lib/scansarif.exp (verify-sarif-file): If "jsonschema" is
            available, use it to verify that the .sarif file complies with the
            SARIF schema.
            * lib/target-supports.exp (check_effective_target_jsonschema):
            New.
    
    Signed-off-by: David Malcolm <dmalcolm@redhat.com>
    (cherry picked from commit a84fe222029ff21903283cc8ee4bc760ebf80ec2)

diff --git a/gcc/testsuite/lib/scansarif.exp b/gcc/testsuite/lib/scansarif.exp
index 1f7b20610b7..3eb38b8102e 100644
--- a/gcc/testsuite/lib/scansarif.exp
+++ b/gcc/testsuite/lib/scansarif.exp
@@ -56,6 +56,9 @@ proc scan-sarif-file-not { args } {
 #
 # Assuming python3 is available, use verify-sarif-file.py to check
 # that the .sarif file is UTF-8 encoded and is parseable as JSON.
+#
+# Assuming "jsonschema" is available, use it to verify that the .sarif
+# file complies with the SARIF schema.
 
 proc verify-sarif-file { args } {
     global srcdir subdir
@@ -79,4 +82,24 @@ proc verify-sarif-file { args } {
     } else {
 	pass "$what"
     }
+
+    # Verify that the file complies with the SARIF schema.
+
+    # Check that jsonschema is installed.
+    if { ![check_effective_target_jsonschema] } {
+	unsupported "$testcase verify-sarif-file: jsonschema is missing"
+	return	
+    }
+
+    set schema_file $srcdir/lib/sarif-schema-2.1.0.json
+    verbose "schema_file: $schema_file" 2
+
+    set what "$testcase (test .sarif output against SARIF schema)"
+    if [catch {exec jsonschema --instance $output_file $schema_file} res ] {
+	verbose "verify-sarif-file: res: $res" 2
+	fail "$what"
+	return
+    } else {
+	pass "$what"
+    }
 }
diff --git a/gcc/testsuite/lib/target-supports.exp b/gcc/testsuite/lib/target-supports.exp
index 6b8603b1af8..2e44d6cdff6 100644
--- a/gcc/testsuite/lib/target-supports.exp
+++ b/gcc/testsuite/lib/target-supports.exp
@@ -13587,3 +13587,15 @@ proc check_effective_target_heap_trampoline {} {
     }
     return 0
 }
+
+# Return 1 if jsonschema is available.
+
+proc check_effective_target_jsonschema { } {
+    set result [remote_exec host "jsonschema --version"]
+    set status [lindex $result 0]
+    if { $status == 0 } then {
+        return 1;
+    } else {
+        return 0;
+    }
+}

